import data
import pygame
import random
import utilities

X_WIDTH = 640
Y_HEIGHT = 10000
y_speed = 0.0
y_position = 0

CLOUD_COUNT = 200

class Cloud(pygame.sprite.Sprite):
    def __init__(self, x, y, cloud_num, layer):
        pygame.sprite.Sprite.__init__(self)
        self.x = x
        self.y = y
        self.layer = layer
        self.image, self.rect = utilities.load_image('Cloud_small%s.gif' %(cloud_num), -1)
        
    def update(self):
        self.y += y_speed*self.layer
        self.rect.x = self.x
        self.rect.y = self.y
        
def background_handler():
    global y_position
    y_position +=y_speed
    # Change the color of the background image.
    val = 255*(Y_HEIGHT-y_position)/Y_HEIGHT
    if val < 0:
        val = 0
    bg.fill((val, val, val))
    allsprites.update()

def generate_clouds():
    clouds = []
    for layer in 1, 2, 3:
        for i in range(0, int(CLOUD_COUNT/3.0)):
            # x position is anywhere from -200 (off the left side of the screen)
            # to 640
            # y position is anywhere from -200 (off the top of the level) 
            # to 10000
            x_pos = -200 + (random.random() * (X_WIDTH + 200))
            y_pos = -(Y_HEIGHT+200) + (random.random() * (Y_HEIGHT + 200)) + 400
            # There are three different clouds, and three layers of clouds
            cloud = Cloud(x_pos, y_pos*layer, 1+i%3, layer)
            clouds.append(cloud)
    return clouds
        
def init(screen):
    global bg, allsprites
    width, height = screen.get_size()
    bg = pygame.Surface((width, height))
    bg = bg.convert()
    bg.fill((128, 128, 128))
    
    screen.blit(bg, (0, 0))
    pygame.display.flip()

    clouds = generate_clouds()

    allsprites = pygame.sprite.RenderPlain(clouds)