
# Bird animations and shiz

import pygame
import random
import utilities

X_WIDTH = 640
Y_HEIGHT = 10000
y_speed = 0.0
x_speed = 1.0

BIRD_COUNT = 100

class AnimatedSprite(pygame.sprite.Sprite):
    def __init__(self, frames, wait_):
        self.frames = frames
        self.wait_ = wait_
        self.curTime = 0
        self.frameIdx = 0
        self.rect = pygame.Rect(0, 0, w, h)

    def tick(self):
        self.curTime += 1
        if (self.curTime > self.wait_):
            self.curTime = 0
            self.frameIdx = (self.frameIdx + 1) % len(self.frames)
            self.image = self.frames[self.frameIdx]
    
#    def _getRect(self):
#        return (self.pos[0], self.pos[1], self.width, self.height)
#    rect = property(_getRect)

class GameSprite(pygame.sprite.Sprite):
    def tick(self):
        momentum = getattr(self, "momentum", (0,0))
        #self.rect = self.rect.move(*momentum)

class Bird(AnimatedSprite, GameSprite):
    def __init__(self, x, y, x_direction, momentum):
        GameSprite.__init__(self)
        self.x = x
        self.y = y
        self.x_direction = x_direction
        self.image, self.rect = utilities.load_image('small-wingup.gif', -1)

    def tick(self):
        AnimatedSprite.tick(self)
        GameSprite.tick(self)

    def update(self):
        self.y += y_speed * 3 # Currently this has to be multiplied by 3
        # because of the way clouds (3 layers) are implemented
        self.x += x_speed * self.x_direction
        if self.x < 0 or self.x > X_WIDTH:
            self.x_direction = -self.x_direction
        self.rect.x = self.x
        self.rect.y = self.y
        

def bird_handler():
    allsprites.update()

def generate_birds():
    birds = []
    for i in range(0, BIRD_COUNT):
        x_pos = random.random() * X_WIDTH
        y_pos = random.random() * Y_HEIGHT - (Y_HEIGHT - 400)
        x_direction = i%2
        if x_direction == 0:
            x_direction = -1
        bird = Bird(x_pos, y_pos*3, x_direction, 1)
        birds.append(bird)
    return birds

def init(screen):
    global allsprites
    
    birds = generate_birds()
    allsprites = pygame.sprite.RenderPlain(birds)
